import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';

class SdsTextButton extends StatelessWidget {
  final Key? key;

  final VoidCallback? onPressed;

  final VoidCallback? onLongPress;

  final ButtonStyle? style;

  final FocusNode? focusNode;

  final Widget child;

  final bool autofocus;

  final Clip clipBehavior;

  const SdsTextButton({
    this.key,
    required this.onPressed,
    this.onLongPress,
    this.style,
    this.focusNode,
    this.autofocus = false,
    this.clipBehavior = Clip.none,
    required this.child,
  });

  @override
  Widget build(BuildContext context) {
    DateTime? _dateTime;
    int oldFunc = 0;
    return TextButton(
      key: this.key,
      onPressed: () {
        // buttonPress(onPressed, _dateTime, oldFunc);
        DateTime now = DateTime.now();
        if (_dateTime == null ||
            now.difference(_dateTime ?? DateTime.now()) >
                const Duration(seconds: 1) ||
            this.onPressed.hashCode != oldFunc) {
          _dateTime = now;
          oldFunc = this.onPressed.hashCode;
          this.onPressed?.call();
        }
      },
      onLongPress: this.onLongPress,
      style: this.style,
      focusNode: this.focusNode,
      autofocus: this.autofocus,
      clipBehavior: this.clipBehavior,
      child: this.child,
    );
  }
}
